> ## Documentation Index
> Fetch the complete documentation index at: https://cloud.laravel.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create instance

> Create a new instance for an environment.



## OpenAPI

````yaml https://cloud.laravel.com/api-docs/api.json post /environments/{environment}/instances
openapi: 3.1.0
info:
  title: Laravel Cloud
  version: 0.0.1
servers:
  - url: https://cloud.laravel.com/api
security:
  - http: []
tags:
  - name: Applications
  - name: Environments
  - name: Domains
  - name: Commands
  - name: Deployments
  - name: Instances
  - name: Background Processes
  - name: Database Clusters
  - name: Databases
  - name: Database Snapshots
  - name: Database Restores
  - name: Object Storage Buckets
  - name: Bucket Keys
  - name: Caches
  - name: WebSocket Clusters
  - name: WebSocket Applications
  - name: Dedicated Clusters
  - name: Usage
  - name: Meta
  - name: Databases (Legacy)
paths:
  /environments/{environment}/instances:
    post:
      tags:
        - Instances
      summary: Create instance
      description: Create a new instance for an environment.
      operationId: public.environments.instances.store
      parameters:
        - name: environment
          in: path
          required: true
          description: The environment identifier
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateInstanceRequest'
      responses:
        '201':
          description: '`InstanceResource`'
          content:
            application/vnd.api+json:
              schema:
                type: object
                properties:
                  data:
                    $ref: '#/components/schemas/InstanceResource'
                  included:
                    type: array
                    items:
                      anyOf:
                        - $ref: '#/components/schemas/EnvironmentResource'
                        - $ref: '#/components/schemas/BackgroundProcessResource'
                required:
                  - data
        '404':
          $ref: '#/components/responses/ModelNotFoundException'
        '422':
          $ref: '#/components/responses/ValidationException'
components:
  schemas:
    CreateInstanceRequest:
      type: object
      properties:
        name:
          type: string
          minLength: 3
          maxLength: 40
        type:
          type: string
          enum:
            - service
            - managed_queue
        size:
          $ref: '#/components/schemas/InstanceSize'
        scaling_type:
          $ref: '#/components/schemas/InstanceScalingType'
        max_replicas:
          type: integer
          description: >-
            The maximum number of replicas the instance can scale to. Only
            applicable to the `custom` scaling type, and rejected when used with
            `auto`.
          example: 10
        min_replicas:
          type: integer
          description: >-
            The minimum number of replicas the instance runs. Only applicable to
            the `custom` scaling type, and rejected when used with `auto`. Not
            applicable to managed queues, which always scale to zero when idle.
          example: 1
        uses_scheduler:
          type: boolean
        sleep_with_app:
          type: boolean
          description: >-
            Whether worker replicas scale to zero alongside the app cluster,
            waking when they receive traffic. Only applicable to worker
            (service) instances.
          example: true
        scaling_cpu_threshold_percentage:
          type:
            - integer
            - 'null'
          minimum: 50
          maximum: 95
        scaling_memory_threshold_percentage:
          type:
            - integer
            - 'null'
          minimum: 50
          maximum: 95
        visibility_timeout:
          type: integer
          minimum: 0
          maximum: 43200
        polling_interval:
          type: integer
          minimum: 1
          maximum: 60
        shutdown_timeout:
          type: integer
          minimum: 1
          maximum: 0
        background_processes:
          type: array
          items:
            type: object
            properties:
              type:
                $ref: '#/components/schemas/DaemonType'
              processes:
                type: integer
                minimum: 1
                maximum: 10
              command:
                type: string
                description: >-
                  Custom command to run. Required when type is 'custom'. Not
                  applicable for 'worker' type.
                example: php artisan my:command
              config:
                type: object
                properties:
                  connection:
                    type: string
                    description: >-
                      The queue connection name. Only applicable for 'worker'
                      type background processes. Managed queues must use
                      'cloud'.
                    example: redis
                  queue:
                    type: string
                    description: >-
                      The queue name(s) to process. Can be comma-separated for
                      multiple queues. Only applicable for 'worker' type
                      background processes.
                    example: default,emails
                  tries:
                    type: integer
                    description: >-
                      Number of times a job should be attempted. Only applicable
                      for 'worker' type background processes.
                    example: 3
                  backoff:
                    type: integer
                    description: >-
                      Number of seconds to wait before retrying a failed job.
                      Only applicable for 'worker' type background processes.
                    example: 30
                  sleep:
                    type: integer
                    description: >-
                      Number of seconds to sleep when no jobs are available.
                      Only applicable for 'worker' type background processes.
                    example: 3
                  rest:
                    type: integer
                    description: >-
                      Number of seconds to rest between jobs. Only applicable
                      for 'worker' type background processes.
                    example: 0
                  timeout:
                    type: integer
                    description: >-
                      Number of seconds a job can run before timing out. Only
                      applicable for 'worker' type background processes.
                    example: 60
                  force:
                    type: boolean
                    description: >-
                      Force the worker to run even in maintenance mode. Only
                      applicable for 'worker' type background processes.
                    example: false
            required:
              - type
              - processes
      required:
        - name
        - type
        - size
        - scaling_type
        - min_replicas
        - visibility_timeout
        - polling_interval
        - shutdown_timeout
      title: CreateInstanceRequest
    InstanceResource:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          enum:
            - instances
        attributes:
          type: object
          properties:
            name:
              type: string
            type:
              $ref: '#/components/schemas/InstanceType'
            size:
              $ref: '#/components/schemas/InstanceSize'
            scaling_type:
              $ref: '#/components/schemas/InstanceScalingType'
            min_replicas:
              type: integer
            max_replicas:
              type: integer
            queue_status:
              anyOf:
                - $ref: '#/components/schemas/SqsQueueStatus'
                  description: >-
                    Current lifecycle status of the managed queue. Null for
                    non-queue instances.
                - type: 'null'
            paused:
              type:
                - boolean
                - 'null'
              description: >-
                Whether the managed queue is currently paused. Null for
                non-queue instances.
            is_default:
              type:
                - boolean
                - 'null'
              description: >-
                Whether this is the environment's default managed queue. Null
                for non-queue instances.
            visibility_timeout:
              type:
                - integer
                - 'null'
              description: >-
                How long, in seconds (0–43200), a received job stays hidden from
                other workers before it becomes available again. Null for
                non-queue instances.
            polling_interval:
              type:
                - integer
                - 'null'
              description: >-
                How often, in seconds (1–60), the queue is polled for new jobs.
                Null for non-queue instances.
            shutdown_timeout:
              type:
                - integer
                - 'null'
            uses_scheduler:
              type: boolean
            sleep_with_app:
              type:
                - boolean
                - 'null'
            scaling_cpu_threshold_percentage:
              type:
                - integer
                - 'null'
            scaling_memory_threshold_percentage:
              type:
                - integer
                - 'null'
            created_at:
              type:
                - string
                - 'null'
              format: date-time
          required:
            - name
            - type
            - size
            - scaling_type
            - min_replicas
            - max_replicas
            - queue_status
            - paused
            - is_default
            - visibility_timeout
            - polling_interval
            - shutdown_timeout
            - uses_scheduler
            - sleep_with_app
            - scaling_cpu_threshold_percentage
            - scaling_memory_threshold_percentage
            - created_at
        relationships:
          type: object
          properties:
            environment:
              type: object
              properties:
                data:
                  anyOf:
                    - $ref: '#/components/schemas/EnvironmentResourceIdentifier'
                    - type: 'null'
              required:
                - data
            backgroundProcesses:
              type: object
              properties:
                data:
                  type: array
                  items:
                    $ref: '#/components/schemas/BackgroundProcessResourceIdentifier'
              required:
                - data
      required:
        - id
        - type
      title: InstanceResource
    EnvironmentResource:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          enum:
            - environments
        attributes:
          type: object
          properties:
            name:
              type: string
            slug:
              type: string
            status:
              $ref: '#/components/schemas/EnvironmentStatus'
            created_from_automation:
              type: boolean
            vanity_domain:
              type: string
            php_major_version:
              type: string
              enum:
                - '8.2'
                - '8.3'
                - '8.4'
                - '8.5'
            build_command:
              type:
                - string
                - 'null'
            node_version:
              $ref: '#/components/schemas/NodeVersion'
            deploy_command:
              type:
                - string
                - 'null'
            uses_octane:
              type: boolean
            uses_hibernation:
              type: boolean
            hibernation_wake_up_interval:
              type:
                - integer
                - 'null'
            uses_push_to_deploy:
              type: boolean
            uses_deploy_hook:
              type: boolean
            environment_variables:
              type: array
              items:
                type: object
                properties:
                  key:
                    type: string
                  value:
                    type: string
                required:
                  - key
                  - value
            network_settings:
              type: object
              properties:
                cache:
                  type: object
                  properties:
                    strategy:
                      type: string
                  required:
                    - strategy
                response_headers:
                  type: object
                  properties:
                    frame:
                      type: string
                    content_type:
                      type: string
                    hsts:
                      type: object
                      properties:
                        max_age:
                          type: integer
                        include_subdomains:
                          type: boolean
                        preload:
                          type: boolean
                      required:
                        - max_age
                        - include_subdomains
                        - preload
                  required:
                    - frame
                    - content_type
                    - hsts
                firewall:
                  type: object
                  properties:
                    bot_categories:
                      type: array
                      items:
                        $ref: '#/components/schemas/BotControlCategory'
                    rate_limit:
                      type: object
                      properties:
                        '429':
                          type: boolean
                        level:
                          $ref: '#/components/schemas/RateLimitLevel'
                        per_minute:
                          $ref: '#/components/schemas/RateLimitPerMinute'
                        4xx:
                          type: boolean
                      required:
                        - level
                        - per_minute
                        - 4xx
                        - '429'
                    under_attack_mode_started_at:
                      type: string
                    block_path:
                      type: boolean
                  required:
                    - bot_categories
                    - rate_limit
                    - under_attack_mode_started_at
                    - block_path
                content_converter:
                  type: boolean
              required:
                - cache
                - response_headers
                - firewall
                - content_converter
            created_at:
              type:
                - string
                - 'null'
              format: date-time
          required:
            - name
            - slug
            - status
            - created_from_automation
            - vanity_domain
            - php_major_version
            - build_command
            - node_version
            - deploy_command
            - uses_octane
            - uses_hibernation
            - hibernation_wake_up_interval
            - uses_push_to_deploy
            - uses_deploy_hook
            - environment_variables
            - network_settings
            - created_at
        relationships:
          type: object
          properties:
            application:
              type: object
              properties:
                data:
                  anyOf:
                    - $ref: '#/components/schemas/ApplicationResourceIdentifier'
                    - type: 'null'
              required:
                - data
            branch:
              type: object
              properties:
                data:
                  anyOf:
                    - $ref: '#/components/schemas/BranchResourceIdentifier'
                    - type: 'null'
              required:
                - data
            deployments:
              type: object
              properties:
                data:
                  type: array
                  items:
                    $ref: '#/components/schemas/DeploymentResourceIdentifier'
              required:
                - data
            currentDeployment:
              type: object
              properties:
                data:
                  anyOf:
                    - $ref: '#/components/schemas/DeploymentResourceIdentifier'
                    - type: 'null'
              required:
                - data
            domains:
              type: object
              properties:
                data:
                  type: array
                  items:
                    $ref: '#/components/schemas/DomainResourceIdentifier'
              required:
                - data
            primaryDomain:
              type: object
              properties:
                data:
                  anyOf:
                    - $ref: '#/components/schemas/DomainResourceIdentifier'
                    - type: 'null'
              required:
                - data
            instances:
              type: object
              properties:
                data:
                  type: array
                  items:
                    $ref: '#/components/schemas/InstanceResourceIdentifier'
              required:
                - data
            database:
              type: object
              properties:
                data:
                  anyOf:
                    - $ref: '#/components/schemas/DatabaseSchemaResourceIdentifier'
                    - type: 'null'
              required:
                - data
            cache:
              type: object
              properties:
                data:
                  anyOf:
                    - $ref: '#/components/schemas/CacheResourceIdentifier'
                    - type: 'null'
              required:
                - data
            buckets:
              type: object
              properties:
                data:
                  type: array
                  items:
                    $ref: '#/components/schemas/FilesystemResourceIdentifier'
              required:
                - data
            websocketApplication:
              type: object
              properties:
                data:
                  anyOf:
                    - $ref: >-
                        #/components/schemas/WebsocketApplicationResourceIdentifier
                    - type: 'null'
              required:
                - data
        links:
          type: object
          properties:
            self:
              $ref: '#/components/schemas/Link'
          required:
            - self
      required:
        - id
        - type
        - links
      title: EnvironmentResource
    BackgroundProcessResource:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          enum:
            - background_processes
        attributes:
          type: object
          properties:
            type:
              $ref: '#/components/schemas/DaemonType'
            processes:
              type: integer
            command:
              type: string
            config:
              type: array
              items: {}
            strategy_type:
              $ref: '#/components/schemas/DaemonStrategyType'
            strategy_threshold:
              type:
                - integer
                - 'null'
            created_at:
              type:
                - string
                - 'null'
              format: date-time
          required:
            - type
            - processes
            - command
            - config
            - strategy_type
            - strategy_threshold
            - created_at
        relationships:
          type: object
          properties:
            instance:
              type: object
              properties:
                data:
                  anyOf:
                    - $ref: '#/components/schemas/InstanceResourceIdentifier'
                    - type: 'null'
              required:
                - data
      required:
        - id
        - type
      title: BackgroundProcessResource
    InstanceSize:
      type: string
      enum:
        - flex-512mb
        - flex-1gb
        - flex-2gb
        - flex.c-1vcpu-256mb
        - flex.g-1vcpu-512mb
        - flex.m-1vcpu-1gb
        - flex.c-2vcpu-512mb
        - flex.g-2vcpu-1gb
        - flex.m-2vcpu-2gb
        - flex.c-4vcpu-1gb
        - flex.g-4vcpu-2gb
        - flex.m-4vcpu-4gb
        - flex.c-8vcpu-2gb
        - flex.g-8vcpu-4gb
        - flex.m-8vcpu-8gb
        - pro.c-1vcpu-1gb
        - pro.g-1vcpu-2gb
        - pro.m-1vcpu-4gb
        - pro.c-2vcpu-2gb
        - pro.g-2vcpu-4gb
        - pro.m-2vcpu-8gb
        - pro.c-4vcpu-4gb
        - pro.g-4vcpu-8gb
        - pro.m-4vcpu-16gb
        - pro.c-8vcpu-8gb
        - pro.g-8vcpu-16gb
        - pro.m-8vcpu-32gb
        - dedicated.c-1vcpu-2gb
        - dedicated.g-1vcpu-4gb
        - dedicated.m-1vcpu-8gb
        - dedicated.c-2vcpu-4gb
        - dedicated.g-2vcpu-8gb
        - dedicated.m-2vcpu-16gb
        - dedicated.c-4vcpu-8gb
        - dedicated.g-4vcpu-16gb
        - dedicated.m-4vcpu-32gb
        - dedicated.c-8vcpu-16gb
        - dedicated.g-8vcpu-32gb
        - dedicated.m-8vcpu-64gb
        - mq-pro-256mb
        - mq-pro-512mb
        - mq-pro-1gb
        - mq-pro-2gb
        - mq-pro-4gb
        - mq-pro-8gb
        - mq-dedicated-256mb
        - mq-dedicated-512mb
        - mq-dedicated-1gb
        - mq-dedicated-2gb
        - mq-dedicated-4gb
        - mq-dedicated-8gb
      title: InstanceSize
    InstanceScalingType:
      type: string
      enum:
        - none
        - custom
        - auto
      title: InstanceScalingType
    DaemonType:
      type: string
      enum:
        - worker
        - custom
      title: DaemonType
    InstanceType:
      type: string
      enum:
        - app
        - service
        - queue
        - managed_queue
      title: InstanceType
    SqsQueueStatus:
      type: string
      enum:
        - creating
        - updating
        - available
        - deleting
        - deleted
        - unknown
      title: SqsQueueStatus
    EnvironmentResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - environments
        id:
          type: string
      required:
        - type
        - id
      title: EnvironmentResourceIdentifier
    BackgroundProcessResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - background_processes
        id:
          type: string
      required:
        - type
        - id
      title: BackgroundProcessResourceIdentifier
    EnvironmentStatus:
      type: string
      enum:
        - deploying
        - running
        - hibernating
        - stopped
      title: EnvironmentStatus
    NodeVersion:
      type: string
      enum:
        - '20'
        - '22'
        - '24'
      title: NodeVersion
    BotControlCategory:
      type: string
      enum:
        - academic_research
        - accessibility
        - advertising_and_marketing
        - aggregator
        - ai_assistant
        - ai_crawler
        - ai_search
        - feed_fetcher
        - monitoring_and_analytics
        - page_preview
        - search_engine_crawler
        - search_engine_optimization
        - security
        - social_media_marketing
        - webhooks
        - other
      title: BotControlCategory
    RateLimitLevel:
      type: string
      enum:
        - challenge
        - throttle
        - ban
      title: RateLimitLevel
    RateLimitPerMinute:
      type: integer
      enum:
        - 100
        - 300
        - 500
        - 750
        - 1000
      title: RateLimitPerMinute
    ApplicationResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - applications
        id:
          type: string
      required:
        - type
        - id
      title: ApplicationResourceIdentifier
    BranchResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - branches
        id:
          type: string
      required:
        - type
        - id
      title: BranchResourceIdentifier
    DeploymentResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - deployments
        id:
          type: string
      required:
        - type
        - id
      title: DeploymentResourceIdentifier
    DomainResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - domains
        id:
          type: string
      required:
        - type
        - id
      title: DomainResourceIdentifier
    InstanceResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - instances
        id:
          type: string
      required:
        - type
        - id
      title: InstanceResourceIdentifier
    DatabaseSchemaResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - databaseSchemas
        id:
          type: string
      required:
        - type
        - id
      title: DatabaseSchemaResourceIdentifier
    CacheResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - caches
        id:
          type: string
      required:
        - type
        - id
      title: CacheResourceIdentifier
    FilesystemResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - filesystems
        id:
          type: string
      required:
        - type
        - id
      title: FilesystemResourceIdentifier
    WebsocketApplicationResourceIdentifier:
      type: object
      properties:
        type:
          type: string
          enum:
            - websocketApplications
        id:
          type: string
      required:
        - type
        - id
      title: WebsocketApplicationResourceIdentifier
    Link:
      type: object
      properties:
        href:
          type: string
          format: uri
        rel:
          type: string
        describedby:
          type: string
        title:
          type: string
        type:
          type: string
        hreflang:
          anyOf:
            - type: string
            - type: array
              items:
                type: string
        meta:
          type: object
      required:
        - href
      title: Link
    DaemonStrategyType:
      type: string
      enum:
        - none
        - growth_rate
        - queue_size
      title: DaemonStrategyType
  responses:
    ModelNotFoundException:
      description: Not found
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                type: string
                description: Error overview.
            required:
              - message
    ValidationException:
      description: Validation error
      content:
        application/json:
          schema:
            type: object
            properties:
              message:
                type: string
                description: Errors overview.
              errors:
                type: object
                description: A detailed description of each field that failed validation.
                additionalProperties:
                  type: array
                  items:
                    type: string
            required:
              - message
              - errors
  securitySchemes:
    http:
      type: http
      description: The Bearer Token generated on the Cloud UI.
      scheme: bearer
      bearerFormat: bearer

````